%global momorel 3

Summary: QEMU is a FAST! processor emulator
Name: qemu
Version: 0.12.5
Release: %{momorel}m%{?dist}
Epoch: 0
License: GPLv2+ and LGPLv2+ and BSD
Group: Development/Tools
URL: http://www.qemu.org/

# Allow one off builds to be minimalized without foreign
# architecture support (--with x86only):
%define with_x86only  %{?_with_x86only:     1} %{?!_with_x86only:     0}

Source0: http://dl.sourceforge.net/sourceforge/kvm/qemu-kvm-%{version}.tar.gz
NoSource: 0
Source1: qemu.init

# Loads kvm kernel modules at boot
Source2: kvm.modules

# Creates /dev/kvm
Source3: 80-kvm.rules

# KSM control scripts
Source4: ksm.init
Source5: ksm.sysconfig
Source6: ksmtuned.init
Source7: ksmtuned
Source8: ksmtuned.conf

######Patch01: qemu-0.12.2-underscorejp.patch

# virtio-console changes for the F13 VirtioSerial feature
Patch01: qemu-virtio-Remove-duplicate-macro-definition-for-max.-v.patch
Patch02: qemu-virtio-console-qdev-conversion-new-virtio-serial-b.patch
Patch03: qemu-virtio-serial-bus-Maintain-guest-and-host-port-open.patch
Patch04: qemu-virtio-serial-bus-Add-a-port-name-property-for-po.patch
Patch05: qemu-virtio-serial-bus-Add-ability-to-hot-unplug-ports.patch
Patch06: qemu-virtio-serial-Add-a-virtserialport-device-for-gen.patch
Patch07: qemu-Move-virtio-serial-to-Makefile.objs.patch
Patch08: qemu-virtio-serial-Use-MSI-vectors-for-port-virtqueues.patch
Patch09: qemu-virtio-console-Rename-virtio-serial.c-back-to-virti.patch

# VHostNet Patches
Patch11: qemu-net-add-API-to-disable-enable-polling.patch
Patch12: qemu-virtio-rename-features-guest_features.patch
Patch13: qemu-qdev-add-bit-property-type.patch
Patch14: qemu-qdev-fix-thinko-leading-to-guest-crashes.patch
Patch15: qemu-virtio-add-features-as-qdev-properties.patch
Patch16: qemu-virtio-net-mac-property-is-mandatory.patch
Patch17: qemu-exec-memory-notifiers.patch
Patch18: qemu-kvm-add-API-to-set-ioeventfd.patch
Patch19: qemu-notifier-event-notifier-implementation.patch
Patch20: qemu-virtio-add-notifier-support.patch
Patch21: qemu-virtio-add-APIs-for-queue-fields.patch
Patch22: qemu-virtio-add-status-change-callback.patch
Patch23: qemu-virtio-move-typedef-to-qemu-common.patch
Patch24: qemu-virtio-pci-fill-in-notifier-support.patch
Patch25: qemu-tap-add-interface-to-get-device-fd.patch
Patch26: qemu-vhost-vhost-net-support.patch
Patch27: qemu-tap-add-vhost-vhostfd-options.patch
Patch28: qemu-tap-add-API-to-retrieve-vhost-net-header.patch
Patch29: qemu-virtio-net-vhost-net-support.patch
Patch30: qemu-kvm-add-vhost.h-header.patch
Patch31: qemu-kvm-irqfd-support.patch
Patch32: qemu-msix-add-mask-unmask-notifiers.patch
Patch33: qemu-virtio-pci-irqfd-support.patch
Patch34: qemu-virtio-avoid-crash-with-non-tap-backends.patch
Patch35: qemu-virtio-serial-features-build-fix.patch
Patch36: qemu-virtio-pci-irqfd-fix-nonkvm-build.patch
Patch37: qemu-vhost-add-configure-check.patch

# Fixes from upstream  
Patch38: 0038-msix-migration-fix.patch
Patch39: 0039-vhost-logging-thinko-fix.patch
Patch40: 0040-vhost-move-vhost_set_vq_addr.patch
Patch41: 0041-vhost-used-addr-migration-fix.patch
Patch42: 0042-vhost-fix-used-logging-size-math.patch
Patch43: 0043-vhost-logging-mistake-enable-not-disable-log.patch
Patch44: 0044-vhost-fix-log-base.patch
Patch45: 0045-pc-Add-a-Fedora-13-machine-type-that-contains-backpo.patch
Patch46: 0046-pc-Add-backward-compatibility-options-for-virtio-ser.patch
Patch47: 0047-virtio-serial-don-t-set-MULTIPORT-for-1-port-dev.patch
Patch48: 0048-virtio-serial-pci-Allow-MSI-to-be-disabled.patch
Patch49: 0049-migration-Clear-fd-also-in-error-cases.patch
Patch50: 0050-raw-posix-Detect-CDROM-via-ioctl-on-linux.patch
Patch51: 0051-usb-linux-increase-buffer-for-USB-control-requests.patch
Patch52: 0052-virtio-console-patches.patch
Patch55: 0055-boot-remove-unused-boot_devices_bitmap-variable.patch


BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: SDL-devel zlib-devel which texi2html gnutls-devel cyrus-sasl-devel
BuildRequires: libaio-devel
BuildRequires: rsync
BuildRequires: pciutils-devel
BuildRequires: pulseaudio-libs-devel
BuildRequires: ncurses-devel
Requires: %{name}-user = %{epoch}:%{version}-%{release}
Requires: %{name}-system-x86 = %{epoch}:%{version}-%{release}
Requires: %{name}-system-sparc = %{epoch}:%{version}-%{release}
Requires: %{name}-system-arm = %{epoch}:%{version}-%{release}
Requires: %{name}-system-cris = %{epoch}:%{version}-%{release}
Requires: %{name}-system-sh4 = %{epoch}:%{version}-%{release}
Requires: %{name}-system-m68k = %{epoch}:%{version}-%{release}
Requires: %{name}-system-mips = %{epoch}:%{version}-%{release}
Requires: %{name}-system-ppc = %{epoch}:%{version}-%{release}
Requires: %{name}-img = %{epoch}:%{version}-%{release}

%define qemudocdir %{_docdir}/%{name}-%{version}

%description
QEMU is a generic and open source processor emulator which achieves a good
emulation speed by using dynamic translation. QEMU has two operating modes:

 * Full system emulation. In this mode, QEMU emulates a full system (for
   example a PC), including a processor and various peripherials. It can be
   used to launch different Operating Systems without rebooting the PC or
   to debug system code.
 * User mode emulation. In this mode, QEMU can launch Linux processes compiled
   for one CPU on another CPU.

As QEMU requires no host kernel patches to run, it is safe and easy to use.

%package kvm
Summary: QEMU metapackage for KVM support
Group: Development/Tools
%ifarch %{ix86} x86_64
Requires: qemu-system-x86 = %{epoch}:%{version}-%{release}
%endif
%ifarch ppc ppc64
Requires: qemu-system-ppc = %{epoch}:%{version}-%{release}
%endif

%description kvm
This is a meta-package that provides a qemu-system-<arch> package for native
architectures where kvm can be enabled. For example, in an x86 system, this
will install qemu-system-x86

%package  img
Summary: QEMU command line tool for manipulating disk images
Group: Development/Tools
%description img
This package provides a command line tool for manipulating disk images

%package  common
Summary: QEMU common files needed by all QEMU targets
Group: Development/Tools
Requires(post): shadow-utils
Requires(post): chkconfig
Requires(preun): initscripts chkconfig
Requires(postun): initscripts
%description common
QEMU is a generic and open source processor emulator which achieves a good
emulation speed by using dynamic translation.

This package provides the common files needed by all QEMU targets

%package user
Summary: QEMU user mode emulation of qemu targets
Group: Development/Tools
Requires: %{name}-common = %{epoch}:%{version}-%{release}
Requires(post): chkconfig
Requires(preun): initscripts chkconfig
Requires(postun): initscripts
%description user
QEMU is a generic and open source processor emulator which achieves a good
emulation speed by using dynamic translation.

This package provides the user mode emulation of qemu targets

%package system-x86
Summary: QEMU system emulator for x86
Group: Development/Tools
Requires: %{name}-common = %{epoch}:%{version}-%{release}
Provides: kvm = 85
Obsoletes: kvm < 85
Requires: vgabios
Requires: seabios-bin
Requires: gpxe-roms-qemu

%description system-x86
QEMU is a generic and open source processor emulator which achieves a good
emulation speed by using dynamic translation.

This package provides the system emulator for x86. When being run in a x86
machine that supports it, this package also provides the KVM virtualization
platform.

%if !%{with_x86only}
%package system-ppc
Summary: QEMU system emulator for ppc
Group: Development/Tools
Requires: %{name}-common = %{epoch}:%{version}-%{release}
#Requires: openbios-ppc
Provides: openbios-ppc
Obsoletes: openbios-ppc
%description system-ppc
QEMU is a generic and open source processor emulator which achieves a good
emulation speed by using dynamic translation.

This package provides the system emulator for ppc

%package system-sparc
Summary: QEMU system emulator for sparc
Group: Development/Tools
Requires: %{name}-common = %{epoch}:%{version}-%{release}
%description system-sparc
QEMU is a generic and open source processor emulator which achieves a good
emulation speed by using dynamic translation.

This package provides the system emulator for sparc

%package system-arm
Summary: QEMU system emulator for arm
Group: Development/Tools
Requires: %{name}-common = %{epoch}:%{version}-%{release}
%description system-arm
QEMU is a generic and open source processor emulator which achieves a good
emulation speed by using dynamic translation.

This package provides the system emulator for arm

%package system-mips
Summary: QEMU system emulator for mips
Group: Development/Tools
Requires: %{name}-common = %{epoch}:%{version}-%{release}
%description system-mips
QEMU is a generic and open source processor emulator which achieves a good
emulation speed by using dynamic translation.

This package provides the system emulator for mips

%package system-cris
Summary: QEMU system emulator for cris
Group: Development/Tools
Requires: %{name}-common = %{epoch}:%{version}-%{release}
%description system-cris
QEMU is a generic and open source processor emulator which achieves a good
emulation speed by using dynamic translation.

This package provides the system emulator for cris

%package system-m68k
Summary: QEMU system emulator for m68k
Group: Development/Tools
Requires: %{name}-common = %{epoch}:%{version}-%{release}
%description system-m68k
QEMU is a generic and open source processor emulator which achieves a good
emulation speed by using dynamic translation.

This package provides the system emulator for m68k

%package system-sh4
Summary: QEMU system emulator for sh4
Group: Development/Tools
Requires: %{name}-common = %{epoch}:%{version}-%{release}
%description system-sh4
QEMU is a generic and open source processor emulator which achieves a good
emulation speed by using dynamic translation.

This package provides the system emulator for sh4
%endif

%ifarch %{ix86} x86_64
%package kvm-tools
Summary: KVM debugging and diagnostics tools
Group: Development/Tools

%description kvm-tools
This package contains some diagnostics and debugging tools for KVM,
such as kvmtrace and kvm_stat.
%endif

%prep
%setup -q -n qemu-kvm-%{version}

%patch01 -p1
%patch02 -p1
%patch03 -p1
%patch04 -p1
%patch05 -p1
%patch06 -p1
%patch07 -p1
%patch08 -p1
%patch09 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch18 -p1
%patch19 -p1
%patch20 -p1
%patch21 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1
%patch25 -p1
%patch26 -p1
%patch27 -p1
%patch28 -p1
%patch29 -p1
%patch30 -p1
%patch31 -p1
%patch32 -p1
%patch33 -p1
%patch34 -p1
%patch35 -p1
%patch36 -p1
%patch37 -p1
%patch38 -p1
%patch39 -p1
%patch40 -p1
%patch41 -p1
%patch42 -p1
%patch43 -p1
%patch44 -p1
%patch45 -p1
%patch46 -p1
%patch47 -p1
%patch48 -p1
%patch49 -p1
%patch50 -p1
%patch51 -p1
%patch52 -p1
%patch55 -p1

%build
# By default we build everything, but allow x86 to build a minimal version
# with only similar arch target support
%if %{with_x86only}
    buildarch="i386-softmmu x86_64-softmmu i386-linux-user x86_64-linux-user"
%else
    buildarch="i386-softmmu x86_64-softmmu arm-softmmu cris-softmmu m68k-softmmu \
           mips-softmmu mipsel-softmmu mips64-softmmu mips64el-softmmu ppc-softmmu \
           ppcemb-softmmu ppc64-softmmu sh4-softmmu sh4eb-softmmu sparc-softmmu \
           i386-linux-user x86_64-linux-user alpha-linux-user arm-linux-user \
           armeb-linux-user cris-linux-user m68k-linux-user mips-linux-user \
           mipsel-linux-user ppc-linux-user ppc64-linux-user ppc64abi32-linux-user \
           sh4-linux-user sh4eb-linux-user sparc-linux-user sparc64-linux-user \
           sparc32plus-linux-user" \
%endif

# --build-id option is used fedora 8 onwards for giving info to the debug packages.
extraldflags="-Wl,--build-id";
buildldflags="VL_LDFLAGS=-Wl,--build-id"

%ifarch %{ix86} x86_64
# sdl outputs to alsa or pulseaudio depending on system config, but it's broken (#495964)
# alsa works, but causes huge CPU load due to bugs
# oss works, but is very problematic because it grabs exclusive control of the device causing other apps to go haywire
./configure --target-list=x86_64-softmmu \
            --prefix=%{_prefix} \
            --audio-drv-list=pa,sdl,alsa,oss \
            --disable-strip \
            --extra-ldflags=$extraldflags \
            --extra-cflags="$RPM_OPT_FLAGS" \
            --disable-xen

echo "config-host.mak contents:"
echo "==="
cat config-host.mak
echo "==="

make V=1 %{?_smp_mflags} $buildldflags
cp -a x86_64-softmmu/qemu-system-x86_64 qemu-kvm
make clean

cd kvm/user
./configure --prefix=%{_prefix} --kerneldir=$(pwd)/../kernel/
make kvmtrace
cd ../../
%endif

./configure \
    --target-list="$buildarch" \
    --prefix=%{_prefix} \
    --interp-prefix=%{_prefix}/qemu-%%M \
    --audio-drv-list=pa,sdl,alsa,oss \
    --disable-kvm \
    --disable-strip \
    --extra-ldflags=$extraldflags \
    --extra-cflags="$RPM_OPT_FLAGS" \
    --disable-xen

echo "config-host.mak contents:"
echo "==="
cat config-host.mak
echo "==="

make V=1 %{?_smp_mflags} $buildldflags

%install
rm -rf $RPM_BUILD_ROOT

install -D -p -m 0755 %{SOURCE4} $RPM_BUILD_ROOT%{_initscriptdir}/ksm
install -D -p -m 0644 %{SOURCE5} $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/ksm

install -D -p -m 0755 %{SOURCE6} $RPM_BUILD_ROOT%{_initscriptdir}/ksmtuned
install -D -p -m 0755 %{SOURCE7} $RPM_BUILD_ROOT%{_sbindir}/ksmtuned
install -D -p -m 0644 %{SOURCE8} $RPM_BUILD_ROOT%{_sysconfdir}/ksmtuned.conf

%ifarch %{ix86} x86_64
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/modules
mkdir -p $RPM_BUILD_ROOT%{_bindir}/
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/udev/rules.d

install -m 0755 %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/sysconfig/modules/kvm.modules
install -m 0755 kvm/user/kvmtrace $RPM_BUILD_ROOT%{_bindir}/
install -m 0755 kvm/user/kvmtrace_format $RPM_BUILD_ROOT%{_bindir}/
install -m 0755 kvm/kvm_stat $RPM_BUILD_ROOT%{_bindir}/
install -m 0755 qemu-kvm $RPM_BUILD_ROOT%{_bindir}/
install -m 0644 %{SOURCE3} $RPM_BUILD_ROOT%{_sysconfdir}/udev/rules.d
%endif

make prefix="${RPM_BUILD_ROOT}%{_prefix}" \
     bindir="${RPM_BUILD_ROOT}%{_bindir}" \
     sharedir="${RPM_BUILD_ROOT}%{_datadir}/%{name}" \
     mandir="${RPM_BUILD_ROOT}%{_mandir}" \
     docdir="${RPM_BUILD_ROOT}%{_docdir}/%{name}-%{version}" \
     datadir="${RPM_BUILD_ROOT}%{_datadir}/%{name}" install
chmod -x ${RPM_BUILD_ROOT}%{_mandir}/man1/*
install -D -p -m 0755 %{SOURCE1} $RPM_BUILD_ROOT%{_initscriptdir}/qemu
install -D -p -m 0644 -t ${RPM_BUILD_ROOT}%{qemudocdir} Changelog README TODO COPYING COPYING.LIB LICENSE

install -D -p -m 0644 qemu.sasl $RPM_BUILD_ROOT%{_sysconfdir}/sasl2/qemu.conf

rm -rf ${RPM_BUILD_ROOT}%{_datadir}/%{name}/pxe*bin
rm -rf ${RPM_BUILD_ROOT}%{_datadir}/%{name}/vgabios*bin
rm -rf ${RPM_BUILD_ROOT}%{_datadir}/%{name}/bios.bin
# Provides own binary
#rm -rf ${RPM_BUILD_ROOT}%{_datadir}/%{name}/openbios-ppc
#rm -rf ${RPM_BUILD_ROOT}%{_datadir}/%{name}/openbios-sparc32
#rm -rf ${RPM_BUILD_ROOT}%{_datadir}/%{name}/openbios-sparc64
rm -rf ${RPM_BUILD_ROOT}%{_datadir}/%{name}/petalogix-s3adsp1800.dtb
%if %{with_x86only}
rm -rf ${RPM_BUILD_ROOT}%{_datadir}/%{name}/bamboo.dtb
rm -rf ${RPM_BUILD_ROOT}%{_datadir}/%{name}/ppc_rom.bin
rm -rf ${RPM_BUILD_ROOT}%{_datadir}/%{name}/video.x
%endif

# the pxe gpxe images will be symlinks to the images on
# /usr/share/gpxe, as QEMU doesn't know how to look
# for other paths, yet.
pxe_link() {
  ln -s ../gpxe/$2.rom %{buildroot}%{_datadir}/%{name}/pxe-$1.bin
}

pxe_link e1000 e1000-0x100e
pxe_link ne2k_pci rtl8029
pxe_link pcnet pcnet32
pxe_link rtl8139 rtl8139
pxe_link virtio virtio-net
ln -s ../vgabios/VGABIOS-lgpl-latest.bin  %{buildroot}/%{_datadir}/%{name}/vgabios.bin
ln -s ../vgabios/VGABIOS-lgpl-latest.cirrus.bin %{buildroot}/%{_datadir}/%{name}/vgabios-cirrus.bin
ln -s ../seabios/bios.bin %{buildroot}/%{_datadir}/%{name}/bios.bin
%if !%{with_x86only}
# Provides own binary
#ln -s ../openbios/openbios-ppc %{buildroot}/%{_datadir}/%{name}/openbios-ppc
#ln -s ../openbios/openbios-sparc32 %{buildroot}/%{_datadir}/%{name}/openbios-sparc32
#ln -s ../openbios/openbios-sparc64 %{buildroot}/%{_datadir}/%{name}/openbios-sparc64
%endif
%clean
rm -rf $RPM_BUILD_ROOT

%post system-x86
%ifarch %{ix86} x86_64
# load kvm modules now, so we can make sure no reboot is needed.
# If there's already a kvm module installed, we don't mess with it
sh %{_sysconfdir}/sysconfig/modules/kvm.modules
%endif

%post common
getent group kvm >/dev/null || groupadd -g 36 -r kvm
getent group qemu >/dev/null || groupadd -g 107 -r qemu
getent passwd qemu >/dev/null || \
  useradd -r -u 107 -g qemu -G kvm -d / -s /sbin/nologin \
    -c "qemu user" qemu

/sbin/chkconfig --add ksm
/sbin/chkconfig --add ksmtuned

%preun common
if [ $1 -eq 0 ]; then
    /sbin/service ksmtuned stop &>/dev/null || :
    /sbin/chkconfig --del ksmtuned
    /sbin/service ksm stop &>/dev/null || :
    /sbin/chkconfig --del ksm
fi

%postun common
if [ $1 -ge 1 ]; then
    /sbin/service ksm condrestart &>/dev/null || :
    /sbin/service ksmtuned condrestart &>/dev/null || :
fi

%post user
/sbin/chkconfig --add qemu

%preun user
if [ $1 -eq 0 ]; then
    /sbin/service qemu stop &>/dev/null || :
    /sbin/chkconfig --del qemu
fi

%postun user
if [ $1 -ge 1 ]; then
    /sbin/service qemu condrestart &>/dev/null || :
fi

%files
%defattr(-,root,root)

%files kvm
%defattr(-,root,root)

%files common
%defattr(-,root,root)
%dir %{qemudocdir}
%doc %{qemudocdir}/Changelog
%doc %{qemudocdir}/README
%doc %{qemudocdir}/TODO
%doc %{qemudocdir}/qemu-doc.html
%doc %{qemudocdir}/qemu-tech.html
%doc %{qemudocdir}/COPYING
%doc %{qemudocdir}/COPYING.LIB
%doc %{qemudocdir}/LICENSE
%dir %{_datadir}/%{name}/
%{_datadir}/%{name}/keymaps/
%{_mandir}/man1/qemu.1*
%{_mandir}/man8/qemu-nbd.8*
%{_bindir}/qemu-nbd
%config(noreplace) %{_sysconfdir}/sasl2/qemu.conf
%{_initscriptdir}/ksm
%config(noreplace) %{_sysconfdir}/sysconfig/ksm
%{_initscriptdir}/ksmtuned
%{_sbindir}/ksmtuned
%config(noreplace) %{_sysconfdir}/ksmtuned.conf
%files user
%defattr(-,root,root)
%{_initscriptdir}/qemu
%{_bindir}/qemu-i386
%{_bindir}/qemu-x86_64
%if !%{with_x86only}
%{_bindir}/qemu-alpha
%{_bindir}/qemu-arm
%{_bindir}/qemu-armeb
%{_bindir}/qemu-cris
%{_bindir}/qemu-m68k
%{_bindir}/qemu-mips
%{_bindir}/qemu-mipsel
%{_bindir}/qemu-ppc
%{_bindir}/qemu-ppc64
%{_bindir}/qemu-ppc64abi32
%{_bindir}/qemu-sh4
%{_bindir}/qemu-sh4eb
%{_bindir}/qemu-sparc
%{_bindir}/qemu-sparc64
%{_bindir}/qemu-sparc32plus
%endif
%files system-x86
%defattr(-,root,root)
%{_bindir}/qemu
%{_bindir}/qemu-system-x86_64
%{_datadir}/%{name}/bios.bin
%{_datadir}/%{name}/linuxboot.bin
%{_datadir}/%{name}/multiboot.bin
%{_datadir}/%{name}/vapic.bin
%{_datadir}/%{name}/vgabios.bin
%{_datadir}/%{name}/vgabios-cirrus.bin
%{_datadir}/%{name}/pxe-e1000.bin
%{_datadir}/%{name}/pxe-virtio.bin
%{_datadir}/%{name}/pxe-pcnet.bin
%{_datadir}/%{name}/pxe-rtl8139.bin
%{_datadir}/%{name}/pxe-ne2k_pci.bin
%ifarch %{ix86} x86_64
%{_datadir}/%{name}/extboot.bin
%{_bindir}/qemu-kvm
%{_sysconfdir}/sysconfig/modules/kvm.modules
%{_sysconfdir}/udev/rules.d/80-kvm.rules
%files kvm-tools
%defattr(-,root,root,-)
%{_bindir}/kvmtrace
%{_bindir}/kvmtrace_format
%{_bindir}/kvm_stat
%endif
%if !%{with_x86only}
%files system-sparc
%defattr(-,root,root)
%{_bindir}/qemu-system-sparc
%{_datadir}/%{name}/openbios-sparc32
%{_datadir}/%{name}/openbios-sparc64
%files system-arm
%defattr(-,root,root)
%{_bindir}/qemu-system-arm
%files system-mips
%defattr(-,root,root)
%{_bindir}/qemu-system-mips
%{_bindir}/qemu-system-mipsel
%{_bindir}/qemu-system-mips64
%{_bindir}/qemu-system-mips64el
%files system-ppc
%defattr(-,root,root)
%{_bindir}/qemu-system-ppc
%{_bindir}/qemu-system-ppc64
%{_bindir}/qemu-system-ppcemb
%{_datadir}/%{name}/openbios-ppc
%{_datadir}/%{name}/video.x
%{_datadir}/%{name}/bamboo.dtb
%{_datadir}/%{name}/ppc_rom.bin
%files system-cris
%defattr(-,root,root)
%{_bindir}/qemu-system-cris
%files system-m68k
%defattr(-,root,root)
%{_bindir}/qemu-system-m68k
%files system-sh4
%defattr(-,root,root)
%{_bindir}/qemu-system-sh4
%{_bindir}/qemu-system-sh4eb
%endif

%files img
%defattr(-,root,root)
%{_bindir}/qemu-img
%{_bindir}/qemu-io
%{_mandir}/man1/qemu-img.1*

%changelog
* Tue Aug 31 2010 Yohsuke Ooi <meke@momonga-linux.org>
- (0.12.5-3m)
- full rebuild for mo7 release

* Sat Jul 31 2010 Masahiro Takahata <takahata@momonga-linux.org>
- (0.12.5-2m)
- import patch from Fedora
- openbios-{ppc,sparc32,sparc64} provides own package

* Wed Jul 28 2010 Yohsuke Ooi <meke@momonga-linux.org> 
- (0.12.5-1m)
- update 0.12.5

* Sat Jul 10 2010 Yohsuke Ooi <meke@momonga-linux.org> 
- (0.12.4-2m)
- update init scripts

* Thu Jul  8 2010 Yohsuke Ooi <meke@momonga-linux.org> 
- (0.12.4-1m)
- update 0.12.4

* Tue Jan 26 2010 Yasuo Ohgaki <yohgaki@momonga-linux.org>
- (0.12.2-1m)
- sync with Fedora devel

* Mon Dec  7 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.11.0-2m)
- stop daemons

* Sun Dec  6 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.11.0-1m)
- sync with Fedora 12 (2:0.11.0-12)

* Sat Nov 14 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.10.6-2m)
- rebuild against gcc-4.4 and glibc-2.11

* Mon Oct 19 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.10.6-1m)
- [SECURITY] CVE-2009-3616
- update 0.10.6
- import some patches from Fedora 11 (2:0.10.6-7)

* Sat Jun 27 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.10.5-1m)
- sync with Fedora 11, now provides kvm
- use internal openbios instead of openbios-* packages
-- 
-- * Wed Jun 17 2009 Mark McLoughlin <markmc@redhat.com> - 2:0.10.5-3
-- - ppc-on-ppc fix (#504273)
-- - Fix -kernel regression (#506443)
-- 
-- * Wed Jun  3 2009 Mark McLoughlin <markmc@redhat.com> - 2:0.10.5-2
-- - Prevent locked cdrom eject - fixes hang at end of anaconda installs (#501412)
-- - Fix crash with '-net socket,listen=...' (#501264)
-- - Avoid harmless 'unhandled wrmsr' warnings (#499712)
-- 
-- * Sun May 31 2009 Glauber Costa <glommer@redhat.com> - 2:0.10.5-1
-- - Update to 0.10.5, and remove already upstream patches
--     qemu-fix-gcc.patch
--     qemu-fix-load-linux.patch
--     qemu-dma-aio-cancellation1.patch
--     qemu-dma-aio-cancellation2.patch
--     qemu-dma-aio-cancellation3.patch
--     qemu-dma-aio-cancellation4.patch
--     + all cpuid trimming
-- 
--   Conflicts:
--     qemu-roms-more-room.patch
-- 
-- * Mon May 18 2009 Glauber Costa <glommer@redhat.com> - 2:0.10.4-5
-- - Backport cpuid trimming from upstream (#499596)
-- 
-- * Thu May 14 2009 Mark McLoughlin <markmc@redhat.com> - 2:0.10.4-4
-- - Cherry pick more DMA AIO cancellation fixes from upstream (#497170)
-- 
-- * Wed May 13 2009 Mark McLoughlin <markmc@redhat.com> - 2:0.10.4-3
-- - Fix mixup between kvm.modules and the init script (reported by Rich Jones)
-- 
-- * Wed May 13 2009 Mark McLoughlin <markmc@redhat.com> - 2:0.10.4-2
-- - Fix -kernel bustage in upstream 0.10.4
-- 
-- * Tue May 12 2009 Mark McLoughlin <markmc@redhat.com> - 2:0.10.4-1
-- - Update to 0.10.4
-- - Fix yet more qcow2 corruption (#498405)
-- - AIO cancellation fixes (#497170)
-- - Fix VPC image size overflow (#491981)
-- - Fix oops with 2.6.25 virtio guest (#470386)
-- - Enable pulseaudio driver (#495964, #496627)
-- - Fix cpuid initialization
-- - Fix HPET emulation
-- - Fix storage hotplug error handling
-- - Migration fixes
-- - Block range checking fixes
-- - Make PCI config status register read-only
-- - Handle newer Xorg keymap names
-- - Don't leak memory on NIC hot-unplug
-- - Hook up keypad keys for qemu console emulation
-- - Correctly run on kernels lacking mmu notifiers
-- - Support DDIM option ROMs
-- - Fix PCI NIC error handling
-- - Fix in-kernel LAPIC initialization
-- - Fix broken e1000 PCI config space
-- - Drop some patches which have been upstreamed
-- - Drop the make-release script; we have an official tarball now
-- 
-- * Tue May 12 2009 Glauber Costa <glommer@redhat.com> - 2:0.10-18
-- - move option rom setup function to the beginning of the file. This
--   avoids static vs non-static issues, and is the way upstream does
-- 
-- * Tue May 12 2009 Glauber Costa <glommer@redhat.com> - 2:0.10-17
-- - fix reboot with -kernel parameter (#499666)
-- 
-- * Fri May  1 2009 Mark McLoughlin <markmc@redhat.com> - 2:0.10-16
-- - Really provide qemu-kvm as a metapackage
-- 
-- * Fri Apr 27 2009 Glauber Costa <glommer@redhat.com> - 2:0.10-15
-- - provide qemu-kvm as a metapackage
-- 
-- * Fri Apr 24 2009 Mark McLoughlin <markmc@redhat.com> - 2:0.10-14
-- - Fix source numbering typos caused by make-release addition
-- 
-- * Thu Apr 23 2009 Mark McLoughlin <markmc@redhat.com> - 2:0.10-13
-- - Improve instructions for generating the tarball
-- 
-- * Tue Apr 21 2009 Mark McLoughlin <markmc@redhat.com> - 2:0.10-12
-- - Another qcow2 image corruption fix (#496642)
-- 
-- * Mon Apr 20 2009 Mark McLoughlin <markmc@redhat.com> - 2:0.10-11
-- - Fix qcow2 image corruption (#496642)
-- 
-- * Sun Apr 19 2009 Mark McLoughlin <markmc@redhat.com> - 2:0.10-10
-- - Run sysconfig.modules from %post on x86_64 too (#494739)
-- 
-- * Sun Apr 19 2009 Mark McLoughlin <markmc@redhat.com> - 2:0.10-9
-- - Align VGA ROM to 4k boundary - fixes 'qemu-kvm -std vga' (#494376)
-- 
-- * Tue Apr  14 2009 Glauber Costa <glommer@redhat.com> - 2:0.10-8
-- - Provide qemu-kvm conditional on the architecture.
-- 
-- * Thu Apr  9 2009 Mark McLoughlin <markmc@redhat.com> - 2:0.10-7
-- - Add a much cleaner fix for vga segfault (#494002)
-- 
-- * Sun Apr  5 2009 Glauber Costa <glommer@redhat.com> - 2:0.10-6
-- - Fixed qcow2 segfault creating disks over 2TB. #491943
-- 
-- * Fri Apr  3 2009 Mark McLoughlin <markmc@redhat.com> - 2:0.10-5
-- - Fix vga segfault under kvm-autotest (#494002)
-- - Kill kernelrelease hack; it's not needed
-- - Build with "make V=1" for more verbose logs
-- 
-- * Thu Apr 02 2009 Glauber Costa <glommer@redhat.com> - 2:0.10-4
-- - Support botting gpxe roms.
-- 
-- * Wed Apr 01 2009 Glauber Costa <glommer@redhat.com> - 2:0.10-2
-- - added missing patch. love for CVS.
-- 
-- * Wed Apr 01 2009 Glauber Costa <glommer@redhat.com> - 2:0.10-1
-- - Include debuginfo for qemu-img
-- - Do not require qemu-common for qemu-img
-- - Explicitly own each of the firmware files
-- - remove firmwares for ppc and sparc. They should be provided by an external package.
--   Not that the packages exists for sparc in the secondary arch repo as noarch, but they
--   don't automatically get into main repos. Unfortunately it's the best we can do right
--   now.
-- - rollback a bit in time. Snapshot from avi's maint/2.6.30
--   - this requires the sasl patches to come back.
--   - with-patched-kernel comes back.
-- 
-- * Wed Mar 25 2009 Mark McLoughlin <markmc@redhat.com> - 2:0.10-0.12.kvm20090323git
-- - BuildRequires pciutils-devel for device assignment (#492076)
-- 
-- * Mon Mar 23 2009 Glauber Costa <glommer@redhat.com> - 2:0.10-0.11.kvm20090323git
-- - Update to snapshot kvm20090323.
-- - Removed patch2 (upstream).
-- - use upstream's new split package.
-- - --with-patched-kernel flag not needed anymore
-- - Tell how to get the sources.
-- 
-- * Wed Mar 18 2009 Glauber Costa <glommer@redhat.com> - 2:0.10-0.10.kvm20090310git
-- - Added extboot to files list.
-- 
-- * Wed Mar 11 2009 Glauber Costa <glommer@redhat.com> - 2:0.10-0.9.kvm20090310git
-- - Fix wrong reference to bochs bios.
-- 
-- * Wed Mar 11 2009 Glauber Costa <glommer@redhat.com> - 2:0.10-0.8.kvm20090310git
-- - fix Obsolete/Provides pair
-- - Use kvm bios from bochs-bios package.
-- - Using RPM_OPT_FLAGS in configure
-- - Picked back audio-drv-list from kvm package
-- 
-- * Tue Mar 10 2009 Glauber Costa <glommer@redhat.com> - 2:0.10-0.7.kvm20090310git
-- - modify ppc patch
-- 
-- * Tue Mar 10 2009 Glauber Costa <glommer@redhat.com> - 2:0.10-0.6.kvm20090310git
-- - updated to kvm20090310git
-- - removed sasl patches (already in this release)
-- 
-- * Tue Mar 10 2009 Glauber Costa <glommer@redhat.com> - 2:0.10-0.5.kvm20090303git
-- - kvm.modules were being wrongly mentioned at %%install.
-- - update description for the x86 system package to include kvm support
-- - build kvm's own bios. It is still necessary while kvm uses a slightly different
--   irq routing mechanism
-- 
-- * Thu Mar 05 2009 Glauber Costa <glommer@redhat.com> - 2:0.10-0.4.kvm20090303git
-- - seems Epoch does not go into the tags. So start back here.
-- 
-- * Thu Mar 05 2009 Glauber Costa <glommer@redhat.com> - 2:0.10-0.1.kvm20090303git
-- - Use bochs-bios instead of bochs-bios-data
-- - It's official: upstream set on 0.10
-- 
-- * Thu Mar  5 2009 Daniel P. Berrange <berrange@redhat.com> - 2:0.9.2-0.2.kvm20090303git
-- - Added BSD to license list, since many files are covered by BSD
-- 
-- * Wed Mar 04 2009 Glauber Costa <glommer@redhat.com> - 0.9.2-0.1.kvm20090303git
-- - missing a dot. shame on me
-- 
-- * Wed Mar 04 2009 Glauber Costa <glommer@redhat.com> - 0.92-0.1.kvm20090303git
-- - Set Epoch to 2
-- - Set version to 0.92. It seems upstream keep changing minds here, so pick the lowest
-- - Provides KVM, Obsoletes KVM
-- - Only install qemu-kvm in ix86 and x86_64
-- - Remove pkgdesc macros, as they were generating bogus output for rpm -qi.
-- - fix ppc and ppc64 builds
-- 
-- * Tue Mar 03 2009 Glauber Costa <glommer@redhat.com> - 0.10-0.3.kvm20090303git
-- - only execute post scripts for user package.
-- - added kvm tools.
-- 
-- * Tue Mar 03 2009 Glauber Costa <glommer@redhat.com> - 0.10-0.2.kvm20090303git
-- - put kvm.modules into cvs
-- 
-- * Tue Mar 03 2009 Glauber Costa <glommer@redhat.com> - 0.10-0.1.kvm20090303git
-- - Set Epoch to 1
-- - Build KVM (basic build, no tools yet)
-- - Set ppc in ExcludeArch. This is temporary, just to fix one issue at a time.
--   ppc users (IBM ? ;-)) please wait a little bit.
-- 
-- * Tue Mar  3 2009 Daniel P. Berrange <berrange@redhat.com> - 1.0-0.5.svn6666
-- - Support VNC SASL authentication protocol
-- - Fix dep on bochs-bios-data
-- 
-- * Tue Mar 03 2009 Glauber Costa <glommer@redhat.com> - 1.0-0.4.svn6666
-- - use bios from bochs-bios package.
-- 
-- * Tue Mar 03 2009 Glauber Costa <glommer@redhat.com> - 1.0-0.3.svn6666
-- - use vgabios from vgabios package.
-- 
-- * Mon Mar 02 2009 Glauber Costa <glommer@redhat.com> - 1.0-0.2.svn6666
-- - use pxe roms from etherboot package.
-- 
-- * Mon Mar 02 2009 Glauber Costa <glommer@redhat.com> - 1.0-0.1.svn6666
-- - Updated to tip svn (release 6666). Featuring split packages for qemu.
--   Unfortunately, still using binary blobs for the bioses.

* Wed Jan 21 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.9.1-9m)
- rebuild against rpm-4.6

* Sat Jan 17 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.9.1-8m)
- update Patch4 for fuzz=0
- License: GPLv2+ and LGPLv2+

* Tue Dec  9 2008 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.9.1-7m)
- set kernel2627 to 1

* Fri Nov 21 2008 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (0.9.1-6m)
- change URI to new site

* Sun Sep 14 2008 Shigeru Yamazaki <muradaikan@momonga-linux.org>
- (0.9.1-5m)
- add Patch8: qemu-0.9.1-kernel2627.patch
  enable building with kernel-2.6.27 by setting kernel2627 to 1 

* Tue Jul 15 2008 NARITA Koichi <pulsar@momonga-linux.org>
- (0.9.1-4m)
- rebuild against gnutls-2.4.1

* Thu Apr 03 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.9.1-3m)
- rebuild against gcc43

* Sun Mar  9 2008 NARITA Koichi <pulsar@momonga-linux.org>
- (0.9.1-2m)
- [SECURITY] CVE-2008-0928

* Mon Jan  7 2008 Yohsuke Ooi <meke@momonga-linuc.org>
- (0.9.1-1m)
- update 0.9.1

* Sun Sep 23 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (0.9.0-5m)
- disabled debug_package

* Wed Jul 25 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (0.9.0-4m)
- PreReq: chkconfig, initscripts

* Wed Jun 20 2007 Ichiro Nakai <ichiro@n.email.ne.jp>
- (0.9.0-3m)
- disable service at initial start up

* Tue Jun 12 2007 Yohsuke Ooi <meke@momonga-linuc.org>
- (0.9.0-2m)
- use gcc3.4

* Thu Jun  7 2007 Ryu SASAOKA <ryu@momonga-linuc.org>
- (0.9.0-1m)
- update to 0.9.0
- sync FC7 (0.9.0-2)

* Mon Jul 31 2006 Nishio Futoshi <futoshi@momonga-linuc.org>
- (0.8.2-1m)
- update to 0.8.2
- add patch3 (linux/compiler.h)

* Mon May 29 2006 Masanobu Sato <satoshiga@momonga-linux.org>
- (0.8.1-2m)
- add patch for x86_64 to disable sparc-softemu and sparc-user

* Thu May 11 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (0.8.1-1m)
- update 0.8.1
- disable make test

* Sun Jan  8 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (0.8.0-1m)
- update 0.8.0
- use gcc_3_2

* Thu Nov 17 2005 Kazuhiko <kazuhiko@fdiary.net>
- (0.7.2-2m)
- Obsoletes: qemu-arc, qemu-ppc, qemu-sparc

* Sat Nov 12 2005 Kazuhiko <kazuhiko@fdiary.net>
- (0.7.2-1m)

* Sat Jul 23 2005 Mitsuru Shimamura <smbd@momonga-linux.org>
- (0.6.1-4m)
- rebuild against zlib-1.2.3 (CAN-2005-1849)

* Wed Jul 13 2005 Ryu SASAOKA <ryu@momonga-linux.org>
- (0.6.1-3m)
- rebuild against zlib-devel 1.2.2-2m, which fixes CAN-2005-2096.

* Sat Feb 12 2005 Masahiro Takahata <takahata@momonga-linux.org>
- (0.6.1-2m)
- rebuild against SDL-1.2.7-9m

* Wed Nov 17 2004 Kazuhiko <kazuhiko@fdiary.net>
- (0.6.1-1m)
- many bug fixes and new disk image formats
- remove qemu-cpu-exec.patch

* Wed Jul 14 2004 mutecat <mutecat@momonga-linux.org>
- (0.6.0-1m)
- update & add qemu-cpu-exec.patch
- qemu-cflags2.patch qemu-DESTDIR2.patch qemu-noinstall-htmlfiles2.patch
- patch shusei

* Sat Jun 12 2004 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.5.5-2m)
- add qemu-noinstall-htmlfiles.patch
  for fix below
      error: Installed (but unpackaged) file(s) found:
         /usr/share/doc/qemu/qemu-doc.html
         /usr/share/doc/qemu/qemu-tech.html

* Tue May 18 2004 Kazuhiko <kazuhiko@fdiary.net>
- (0.5.5-1m)
- much improved windows 98 support
- VGA support in PowerPC PREP target

* Sat May 01 2004 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.5.4-4m)
- add Patch2: qemu-DESTDIR.patch
- no use makeflags
- no use --interp-prefix

* Sat May  1 2004 Toru Hoshina <t@momonga-linux.org>
- (0.5.4-3m)
- linux_boot.bin
- force _use_internal_dependency_generator as 0.

* Thu Apr 29 2004 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.5.4-2m)
- add Patch1: qemu-non-sdl_static.patch
- add hack for GLIBC_PRIVATE from valgrind.spec

* Wed Apr 28 2004 TABUCHI Takaaki <tab@momonga-linux.org>
- (0.5.4-1m)
- momonganized
- nosrc
- version up to 0.5.4
- comment out patch0
- update patch1, and rename patch0
- use %%{buildroot} nor $(DESTDIR) at makeflags 
- use %%{optflags} nor $RPM_OPT_FLAGS at configure
- tmp comment out %%check
- change License: GPL/LGPL to GPL

* Fri Jan  9 2004 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0:0.5.1-0.fdr.1
- added -cflags patch to apply RPM_OPT_FLAGS
- added -ppc subpackage
- updated to 0.5.1

* Fri Nov 14 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> - 0:0.5.0-0.fdr.1
- updated to 0.5.0
- reworked large parts of the spec-file since upstream enables
  multi-target builds already

* Tue Sep  2 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 0:0.4.3-0.fdr.1.3
- s!%%ifnarch x86!%%ifnarch %%ix86!

* Tue Sep  2 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 0:0.4.3-0.fdr.1.2
- use '-Wl,-z -Wl,execstack' options to prevent crashes on exec-shield stack

* Thu Aug 21 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 0:0.4.3-0.fdr.1.1
- added -nostrip patch

* Thu Aug 21 2003 Enrico Scholz <enrico.scholz@informatik.tu-chemnitz.de> 0:0.4.3-0.fdr.1
- initial build
